.\"
.\" willow - X/Motif based general purpose database front-end.
.\"
.\" Matt Freedman, mattf@cac.washington.edu, September 6, 1994
.\"
.TH WILLOW 1 "6 September 1994"
.SH NAME
willow \- 
.IR W ashington
.IR I nformation
.IR L ooker-upper
.IR L ayered
.IR O ver
.IR W indows
.SH SYNOPSIS
.na
.in +8n
.ti -8n
.I willow
[-cf 
.I file | - ] [X\ Toolkit\ options]
.in -8n
.SH DESCRIPTION
Willow is an X/Motif based general purpose database front-end. Usage
instructions are available via Willow's online help screens. More
information, including a technical report describing Willow's
architecture is available via ftp from 
.I ftp.cac.washington.edu,
in the
pub/willow directory. Also, there is Mosaic home page for Willow
information, accessible via URL:
   http://www.cac.washington.edu/willow/
.PP
There are two Willow mailing lists available --
.I willow-announce,
is for Willow release announcements only. The second,
.I willow-info
is for release announcements and general discussion of Willow by the
user community. To join, send a request to
   willow-announce-request@cac.washington.edu
                or
   willow-info-request@cac.washington.edu. 
.PP
Please send any questions or comments you have
about Willow to
.I willow@cac.washington.edu.
.SH OPTIONS
.I Willow
accepts all of the standard X Toolkit command line options along with the 
additional options:
.TP 2
.B \-cf \fIfile\fP
This flag indicates that rather than reading the configurations for
available databases from the standard /usr/lib/X11/willow/db.conf, Willow
should look at the specified file.
.TP 2
.B \-cf -\fP
This flag indicates that the database configurations should be read
from stdin.
.SH "CUSTOMIZING WILLOW"
When Willow is run directly on the machine which you are logged into,
you can set and save various options via the Options menu. However,
most users (at least at the University of Washington) access Willow
via the campus anonymous Willow servers. In this case, any
customization must be done via the X resource system, i.e. your
.I .Xdefaults
file. Following are the available resources. This information also
appears in the file
.I willow.X
on the ftp server.
.PP
.nf
BASIC RESOURCES
Willow*size: default
  Willow can be run at four standard sizes: small, medium, large, and
  extra-large. The "size" resource has six legal values: default, small,
  medium, large, extra-large, and custom. The value "default" is of
  course the default.  With this value Willow will configure itself to
  be large if your screen is at least 1000x700, otherwise it will be
  small. If you prefer to always run at one of the other sizes uncomment
  the above line, and put in the name of the size you want. The
  value "custom" is discussed in the ADVANCED section below.
   
Willow*printCommand: lpr
  This is the unix command string that Willow will use to print results.
  The default is lpr. If the value is "none", then printing is disabled.
  Users of the UW campus willow servers may find it useful to set
  this resource to "prt -queue " followed by the name of the most
  convenient printer on the prt system.
   
Willow*defaultVirtualBindings:\\
osfBackSpace : <Key>Delete\\n\\
osfDelete    : <Key>BackSpace\\n\\
osfLeft      : <Key>Left\\n\\
osfUp        : <Key>Up\\n\\
osfRight     : <Key>Right\\n\\
osfDown      : <Key>Down\\n\\
osfPageUp    : <Key>Prior\\n\\
osfPageDown  : <Key>Next\\n\\
osfCancel    : <Key>Escape\\n\\
  Certain systems, such as a Macintosh using MacX and some PC
  software combinations do not recognize the backspace key designated
  for a unix keyboard.  These are the keyboards bindings that should
  enable the "delete" (backspace) key on those systems. Note that if 
  you set any of the key-bindings you must set *all* of them. If you do
  not have PageUp and PageDown keys on your keyboard, you might want
  to change the <Key>Prior" and "<Key>Next" to "<Key>F11" and 
  "Key<F12>" (or any other keys you want to use for this purpose).

  Willow's color scheme is controlled by a group of resources as
  follows. Uncomment and replace any of the color values you wish to
  change. The program xrainbow is useful for previewing the available
  colors on your system.
   
Willow*defaultBackground : SkyBlue1
  This is the background color of everything that is not otherwise
  specified. 
   
Willow*defaultForeground : black
  This is the foreground color of everything that is not otherwise
  specified. 
   
Willow*menuBarBackground : SkyBlue1
  Background color of the Search window's menu bar.
   
Willow*menuBarForeground : black
  Foreground color of the Search window's menu bar.
   
Willow*textBackground  : SlateGray1
  Background color of all text display and entry areas.
   
Willow*textForeground  : black
  Foreground color of all text display and entry areas.
   
Willow*imageBackground : white
  Background color of all image areas (just the "About" box and the
  spinning globe dialog box)
   
Willow*imageForeground : black
  Foreground color of all image areas.
   
Willow*buttonBackground : SkyBlue1
  Background color of all push-buttons.
   
Willow*buttonForeground : Black
  Foreground color of all push-buttons.
   
Willow*fieldButtonBackground : SkyBlue1
  Background color of field-labels, and corresponding date-range
  buttons (if any).

Willow*fieldButtonForeground : Black
  Foreground color of field-labels, and corresponding date-range
  buttons (if any).
   
Willow*checkMarkBackground : red
  Color of selected "check-boxes" (limit fields on Search window, and
  currently selected database in Databases menu).
   
  Here is an alternate color scheme for grey-scale displays.
Willow*defaultBackground : grey90
Willow*defaultForeground : black
Willow*menuBarBackground : grey80
Willow*menuBarForeground : black
Willow*textBackground  : white
Willow*textForeground  : black
Willow*imageBackground : white
Willow*imageForeground : black
Willow*buttonBackground : grey90
Willow*buttonForeground : black
Willow*fieldButtonBackground : grey90
Willow*fieldButtonForeground : black
Willow*checkMarkBackground : grey20

Willow*reverseVideo: False
  If you are running Willow on a monochrome display, and you would 
  prefer a white on black display rather than the standard black on 
  white, set the this resource to True. It has no effect if
  you are on a color display

Willow*saveType: local
  This is the type of save that Willow will try to do by default. Legal
  values are local (save to your account on the machine that Willow is
  running on), email (save via electronic mail), and ftp (network save
  via the FTP program). The default is local, unless you are running off
  a non-local server, in which case it is email.
   
Willow*mailAddress:
  This is the e-mail address that Willow will use if the save type is
  email. By default there is no value.
   
Willow*mailSubject: Willow Search Results
  This is the Subject line that Willow use for results saved via e-mail.
   
Willow*ftpHost: 
  This is the machine that Willow will use for ftp saves. By default
  there is no value.
   
Willow*ftpUserID:
  This is the user id that Willow will use for ftp saves. By default
  there is no value.

Willow*ftpAppend: True
  When Willow saves search results via ftp, and the specified file
  name already exists on the destination machine, should it append
  to the file, or overwrite it?

Willow*includeQuery: False
  If this resource is set to True, Willow will include a description
  of the query that generated your results with all of your saved or
  printed retrievals. Can be turned on and off manually via the
  Options menu as well.

Willow*abbreviatedFields: False
  This controls whether Willow retrieves summary and full records
  with fully expanded field names or two-letter abbreviations 
  displayed. You can also set this on the fly via the Options menu.
  Probably the only use for abbreviated fields is for downloading 
  results into your own personal database (such as Reference
  Manager). 
   
Willow*animationDelay : 200
  How many milliseconds Willow waits between each frame of animation
  (i.e. the spinning globe). If it is set to 0, animation is turned off.
   
   
ADVANCED RESOURCES

Willow*textTranslations:\\
Meta<Key>osfDelete: kill-previous-word()\\n\\
Alt<Key>osfDelete:  kill-previous-word()\\n\\
Ctrl<Key>D:         delete-next-character() \\n\\
Meta<Key>D:         kill-next-word() \\n\\
Alt<Key>D:          kill-next-word() \\n\\
Ctrl<Key>K:         kill-to-end-of-line() \\n\\
Ctrl<Key>U:         kill-to-start-of-line() kill-to-end-of-line() \\n\\
Ctrl<Key>W:         kill-selection() \\n\\
Ctrl<Key>Y:         unkill() \\n\\
Ctrl<Key>F:         forward-character() \\n\\
Ctrl<Key>B:         backward-character() \\n\\
Ctrl<Key>A:         beginning-of-line() \\n\\
Ctrl<Key>E:         end-of-line() \\n\\
Meta<Key>F:         forward-word() \\n\\
Alt<Key>F:          forward-word() \\n\\
Meta<Key>B:         backward-word() \\n\\
Alt<Key>B:          backward-word() \\n\\
  The textTranslations resource defines the keyboard shortcuts that
  are available for editing text in any of Willow's type-in areas.
  The default setup, shown above, is modeled after the standard
  bindings for the emacs text editor. See the Open Software
  Foundation's Motif documentation for information on the available
  action procedures (the section on XmText).    


  Fonts are controlled by three resources: textFont is the font used
  in all text display and entry areas; buttonFont is used on all
  pushbuttons; and defaultFont is used everywhere else. The default
  values for these resources depend on what size you are running at.
  Following are the default values for the three resources at large
  size.

Willow*textFont:    -adobe-courier-medium-r*140-75*
Willow*buttonFont:  -adobe-helvetica-bold-r*140-75*
Willow*defaultFont: -adobe-helvetica-bold-r*140-75*
  Note that Willow purposely defaults to using 75dpi fonts. This
  guarantees a correct screen layout. Please be very careful about
  changing these font resources. If you have a 100dpi screen, you are
  better off running Willow in extra-large mode than switching to
  100dpi fonts.

Willow*noBasicMode: False
  If this resource is set to True, Willow will never go into Basic
  Searching mode by itself. However the "Go To Basic Searching"
  button will still be available for appropriate databases.
   
Willow*printDialog: True
  If this resource is set to False, Willow will not pop up the
  "Printing..." dialog box after you press the "Print" button. This
  can be useful if you have set Willow*printCommand to be an X
  program with its own interface that pops up.
    
Willow*echo: False
  If this resource is set to True, all interactions with the database
  host are echoed to stderr.
       
Willow*size: custom
  Setting the value of the size resource to custom requires that you set
  several other resources as well. Following is an example.
  
  You need to set dimensions and positions for each of the four main
  program windows.
Willow*Search.geometry:       580x365+0+1
Willow*Summaries.geometry:    880x500+0-0
Willow*List Browser.geometry: 625x375+130+380
Willow*Full-Record.geometry:  750x700-0+1
  And the position of the Help window
Willow*HelpShell.geometry:    +70+70

  Next, you need to set the following resources which control how closely
  spaced the various user-interface components are.

Willow*XmForm*verticalSpacing: 4
Willow*XmForm*horizontalSpacing: 5
  Vertical and horizontal pixel spacing between items in the four
  main Willow windows.

Willow*XmDialogShell*XmForm*verticalSpacing: 8
Willow*XmDialogShell*XmForm*horizontalSpacing: 5
  Vertical and horizontal pixel spacing between items in all Willow
  pop-up dialog boxes.

Willow*Search*search_box*XmRowColumn.topOffset: 7
 Vertical pixel spacing between the field-labels on the Search window.

 Finally, you need to make sure that all three of the font resources
 discussed above are explicitly set.



Willow*customFields:
  This resource is used for pre-setting which fields you would like
  to appear in your retrieved full-records for the available
  databases. Note that currently only the "uwbrs" driver supports
  custom fields, so this resource will not be usable for Z39.50
  databases. 
  
  The value of the resource consists of individual lines containing a
  database identifier, colon, then a comma separated list of field
  abbreviations. The following example would cause full records
  retrieved in UW Medline to contain only Abstract, Title, and
  Author, and full records in UW Books In Print to contain only
  Title, Author, and ISBN -- 
     Willow*customFields:\\
     UW-MDL1:AB,TI,AU\\n\\
     UW-BINP:TI,AU,IB

  The database identifier can be found for the current database by
  looking under "About this database" in Willow's File menu, and the
  field name abbreviations can be found by setting Abbreviated Fields
  in the Options menu Record Retrieval dialog, then retrieving a
  full-record.

Willow*userInfo:
  This resource can be used to pre-set answers to questions from the
  database, most often user-id and/or password for databases that
  require a manual login. The value of the resource consists of
  individual lines containing a database identifier, colon, question
  identifier, colon, and the value. For example, suppose you have two
  databases in your Database menu which require a user-id and
  password, and the databases are identified by "DB-1" and
  "DB-2". You could set the resource as follows --
      Willow*userInfo:\\
      DB-1:UserID:MyName\\n\\
      DB-1:Password:MyPassword\\n\\
      DB-2:UserID:MyName\\n\\
      DB-2:Password:MyPassword\\n\\
  The values to use for the database identifier and the question
  identifier are displayed in the dialog box title when Willow asks
  you the question. Note that it might not be a good idea to put real
  passwords into your .Xdefaults file.
.fi

.SH AUTHOR
Willow interface and BRS database driver program by Matt
Freedman (mattf@cac.washington.edu), University of Washington
Computing & Communications. Help sub-system by Jim Fox
(fox@cac.washington.edu), UW Computing & Communications.

Z39.50 driver program by Bill Cattey (wdc@athena.mit.edu),
Massachusetts Institute of Technology Information Systems. Based
Z39.50 API by Harold Finkbeiner (harold@forsythe.stanford.edu)
Stanford University Data Center.
