/*
 *   Portions Copyright (C) 1983-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _DIRENT_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _DIRENT_H

#ident "oldstyle @(#) dirent.h 20.1 94/12/04 "


#pragma pack(4)

#define MAXNAMLEN	512	/* maximum filename length  */
#define DIRBUF		1048	/* buffer size for fs-indep. dirs  */

#ifndef _DIR
#define _DIR
typedef struct {
           int dd_fd;     /* file descriptor  */
	   int dd_loc;    /* offset in block  */
	   int dd_size;   /* amount of valid data  */
	   char *dd_buf;  /* directory block  */
} DIR;            /* stream data from opendir()  */

#endif

#ifndef _SYS_TYPES_H
#include <sys/types.h>
#endif

#ifndef _SYS_DIRENT_H
#include <sys/dirent.h>
#endif


extern DIR	*opendir _PARAMS((const char *));
extern DIR	*eopendir();
extern struct dirent	*readdir _PARAMS((DIR *));
extern void	rewinddir _PARAMS((DIR *));
extern int	closedir _PARAMS((DIR *));
extern long	telldir _PARAMS((DIR *));
extern void	seekdir _PARAMS((DIR *, long int));
#define rewinddir(p)	seekdir(p, 0L)

extern struct dirent	*readdir_r();



#pragma pack()

#endif /* _DIRENT_H */
