/*
 *   Portions Copyright (C) 1983-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _TIME_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _TIME_H

#ident "oldstyle @(#) time.h 20.2 95/01/04 "


#ifndef NULL
#define NULL	0
#endif /* NULL */

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int size_t;
#endif
#ifndef _CLOCK_T
#define _CLOCK_T
typedef long clock_t;
#endif
#ifndef _TIME_T
#define _TIME_T
typedef long time_t;
#endif

#ifdef _POSIXTIMERS
#include <sys/sudstime.h>
#endif

#define CLOCKS_PER_SEC	1000000		/* As required by XPG4 and friends */

#pragma pack(4)

#ifndef _STRUCT_TM
#define _STRUCT_TM
struct tm
{
	int	tm_sec;
	int	tm_min;
	int	tm_hour;
	int	tm_mday;
	int	tm_mon;
	int	tm_year;
	int	tm_wday;
	int	tm_yday;
	int	tm_isdst;
#define LTZNMAX 50
	long tm_tzadj;
	char tm_name[LTZNMAX];      /* name of timezone  */
};

#pragma pack()
#endif /* _STRUCT_TM */


#include <sys/timeb.h>
extern int	ftime();
extern char *   nl_cxtime();
extern char *   nl_ascxtime();
extern long	clock();
extern double	difftime _PARAMS((long , long ));
extern time_t	mktime _PARAMS((struct tm *));
extern time_t	time _PARAMS((long *));
extern size_t	strftime _PARAMS((char *, __SIZE_TYPE__ , const char *, const struct tm *));
extern struct tm	*gmtime _PARAMS((const long *)), *gmtime_r();
extern struct tm	*localtime _PARAMS((const long *)), *localtime_r();
extern char	*ctime _PARAMS((const long *)), *ctime_r();
extern char	*asctime _PARAMS((const struct tm *)), *asctime_r();
extern int	cftime _PARAMS((char *, char *, const long *)), ascftime _PARAMS((char *, const char *, const struct tm *));
extern void	tzset();

extern long	timezone, altzone;
extern int	daylight;
extern char	*tzname[];
extern char	*strptime();

extern struct tm	*getdate _PARAMS((const char *));
extern int	getdate_err;



#ifndef difftime
#define difftime(t1, t0) ((double)((t1) - (t0)))
#endif

#endif /* _TIME_H */
