/*
 *   Portions Copyright (C) 1983-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _FCNTL_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _FCNTL_H

#ident "oldstyle @(#) fcntl.h 20.1 94/12/04 "


#include <sys/types.h>
#include <sys/fcntl.h>

#ifndef S_IRWXU
#define S_IRWXU	00700	/* read, write, execute: owner  */
#define S_IRUSR	00400	/* read permission: owner  */
#define S_IWUSR	00200	/* write permission: owner  */
#define S_IXUSR	00100	/* execute permission: owner  */
#define S_IRWXG	00070	/* read, write, execute: group  */
#define S_IRGRP	00040	/* read permission: group  */
#define S_IWGRP	00020	/* write permission: group  */
#define S_IXGRP	00010	/* execute permission: group  */
#define S_IRWXO	00007	/* read, write, execute: other  */
#define S_IROTH	00004	/* read permission: other  */
#define S_IWOTH	00002	/* write permission: other  */
#define S_IXOTH	00001	/* execute permission: other  */
#define S_ISUID	04000	/* set user id on execution  */
#define S_ISGID	02000	/* set group id on execution  */
#endif

#ifndef SEEK_SET
#define SEEK_SET	0	/* Set file pointer to "offset"  */
#define SEEK_CUR	1	/* Set file pointer to current plus "offset"  */
#define SEEK_END	2	/* Set file pointer to EOF plus "offset"  */
#endif

extern int	fcntl _PARAMS((int, int, ...));
extern int	open _PARAMS((const char *, int, ...));
extern int	creat _PARAMS((const char *, unsigned short ));


#endif /* _FCNTL_H */
