/*
 *   Portions Copyright (C) 1983-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _PWD_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _PWD_H

#ident "oldstyle @(#) pwd.h 20.1 94/12/04 "


#include <sys/types.h>

/*
 * Note, packing necessary to keep compatibility with old
 * DS's
 */

#pragma pack(4)

struct passwd
{
	char	*pw_name;
	char	*pw_passwd;
	uid_t	pw_uid;
	short	__pad1; /* Dependent on size of uid_t !!!! */
	gid_t	pw_gid;
	short	__pad2; /* Dependent on size of uid_t !!!! */	
	char	*pw_age;
	char	*pw_comment;
	char	*pw_gecos;
	char	*pw_dir;
	char	*pw_shell;
};


#ifndef _STRUCT_COMMENT
#define _STRUCT_COMMENT
struct comment
{
	char	*c_dept;
	char	*c_name;
	char	*c_acct;
	char	*c_bin;
};
#endif



extern struct passwd	*getpwuid _PARAMS((unsigned short ));
extern struct passwd	*getpwnam _PARAMS((const char *));


extern struct passwd	*getpwent();
extern void	setpwent();
extern void	endpwent();
extern struct passwd	*fgetpwent _PARAMS((FILE *));
extern int	putpwent _PARAMS((const struct passwd *, FILE *));




#pragma pack()

#endif /* _PWD_H */
