/*
 *   Portions Copyright (C) 1984-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _STDIO_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _STDIO_H

#ident "oldstyle @(#) stdio.h 20.1 94/12/04 "

#pragma pack(4)


#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int	size_t;
#endif

#ifndef _FPOS_T
#define _FPOS_T
typedef long	fpos_t;
#endif

#ifndef _WCHAR_T
#define _WCHAR_T
typedef long	wchar_t;
#endif

#ifndef _WINT_T
#define _WINT_T
typedef long	wint_t;
#endif

#ifndef NULL
#define NULL	0
#endif /* NULL */

#ifndef EOF
#define EOF	(-1)
#endif

#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2

#ifndef TMP_MAX
#define TMP_MAX		17576	/* 26 * 26 * 26  */
#endif

#define BUFSIZ		1024	/* default buffer size  */


#if defined(_IBCS2)
#define FOPEN_MAX	60	/* at least this many FILEs available  */
#define _NFILE		60
#else
#define FOPEN_MAX	128
#define _NFILE		128
#endif

#if _SHORT_FILENAMES
#define FILENAME_MAX 14		/* _POSIX_NAME_MAX */
#else
#define FILENAME_MAX	255	/* max # of characters in a path name  */
#endif

#define _IOFBF		0000	/* full buffered  */
#define _IOLBF		0100	/* line buffered  */
#define _IONBF		0004	/* not buffered  */
#define _IOEOF		0020	/* EOF reached on read  */
#define _IOERR		0040	/* I/O error from system  */

#define _IOREAD		0001	/* currently reading  */
#define _IOWRT		0002	/* currently writing  */
#define _IORW		0200	/* opened for reading and writing  */
#define _IOMYBUF	0010	/* stdio malloc()'d buffer  */

#define _SBFSIZ		8

#define L_ctermid	9
#define L_cuserid	9

#define P_tmpdir	"/usr/tmp/"

/* Non name space polluting version of above */
#define _P_tmpdir "/usr/tmp/"

#define L_tmpnam	(sizeof(_P_tmpdir) + 15)


#ifndef _FILE
#define _FILE
typedef struct _FILE_	/* must be binary-compatible with old versions  */
{
	int		_cnt;	/* number of available characters in buffer  */
	unsigned char	*_ptr;	/* next character from/to here in buffer  */
	unsigned char	*_base;	/* the buffer (not really)  */
	unsigned char	_flag;	/* the state of the stream  */
	unsigned char	_file;	/* file descriptor  */
	unsigned char	_buf[2];/* micro buffer as a fall-back  */
} FILE;
#endif /* _FILE */

extern FILE	_iob[];

#define stdin	(&_iob[0])
#define stdout	(&_iob[1])
#define stderr	(&_iob[2])

extern FILE	*fopen _PARAMS((const char *, const char *)), *fdopen _PARAMS((int, const char *)), *freopen _PARAMS((const char *, const char *, FILE *)), *popen _PARAMS((const char *, const char *)), *tmpfile();
extern long	ftell _PARAMS((FILE *));
extern void	clearerr _PARAMS((FILE *)), rewind _PARAMS((FILE *)), setbuf _PARAMS((FILE *, char *));
extern char	*ctermid _PARAMS((char *)), *cuserid _PARAMS((char *)), *fgets _PARAMS((char *, int, FILE *)), *gets _PARAMS((char *)), *tempnam _PARAMS((const char *, const char *)), *tmpnam _PARAMS((char *));
extern int	fclose _PARAMS((FILE *)), feof _PARAMS((FILE *)), ferror _PARAMS((FILE *)), fflush _PARAMS((FILE *)), fileno _PARAMS((FILE *)), fread _PARAMS((void *, __SIZE_TYPE__ , __SIZE_TYPE__ , FILE *)), fwrite _PARAMS((const void *, __SIZE_TYPE__ , __SIZE_TYPE__ , FILE *)),
		fseek _PARAMS((FILE *, long int, int)), fgetc _PARAMS((FILE *)), getc _PARAMS((FILE *)), getchar(), getw _PARAMS((FILE *)), pclose _PARAMS((FILE *)),
		putc _PARAMS((int, FILE *)), putchar _PARAMS((int)), printf _PARAMS((const char *, ...)), fprintf _PARAMS((FILE *, const char *, ...)), sprintf _PARAMS((char *, const char *, ...)),
		vprintf _PARAMS((const char *, __gnuc_va_list)), vfprintf _PARAMS((FILE *, const char *, __gnuc_va_list)), vsprintf _PARAMS((char *, const char *, __gnuc_va_list)), fputc _PARAMS((int, FILE *)), putw _PARAMS((int, FILE *)),
		puts _PARAMS((const char *)), fputs _PARAMS((const char *, FILE *)), scanf _PARAMS((const char *, ...)), fscanf _PARAMS((FILE *, const char *, ...)), sscanf _PARAMS((const char *, const char *, ...)),
		setvbuf _PARAMS((FILE *, char *, int, __SIZE_TYPE__ )), system _PARAMS((const char *)), ungetc _PARAMS((int, FILE *));
extern int	snprintf(), vsnprintf(), vfscanf(), vscanf(), vsscanf();
extern void	funflush();
extern wint_t	fgetwc(), fputwc(), getwc(), getwchar(), putwc(), putwchar();
extern wint_t	ungetwc();
extern wchar_t	*fgetws();
extern int	fputws(), fwprintf(), fwscanf(), wprintf(), wscanf(),
		swprintf(), swscanf(), vfwprintf(), vfwscanf(),
		vwprintf(), vwscanf(), vswprintf(), vswscanf();
extern int	getopt _PARAMS((int, char *const *, const char *)), optind, opterr, optopt;
extern char	*optarg;
extern int	nl_fprintf(), nl_printf, nl_sprintf(),
		nl_fscanf(), nl_scanf, nl_sscanf();

#ifdef _REENTRANT
extern void	flockfile(), funlockfile();
extern int	ftrylockfile(), getc_unlocked(), getchar_unlocked(),
		putc_unlocked(), putchar_unlocked();
#ifndef lint
#define getc_unlocked(p)	(--(p)->_cnt < 0 ? _filbuf(p) : (int) *(p)->_ptr++)
#define putc_unlocked(x, p)	(--(p)->_cnt < 0 ? \
					_flsbuf((unsigned char) (x), (p)) : \
					(int) (*(p)->_ptr++ = (unsigned char) (x)))
#define getchar_unlocked()	getc_unlocked(stdin)
#define putchar_unlocked(x)	putc_unlocked((x), stdout)
#endif
#endif /* _REENTRANT */

#ifndef lint

#ifndef _REENTRANT
#define getc(p)	(--(p)->_cnt < 0 ? _filbuf(p) : (int) *(p)->_ptr++)
#define putc(x, p)	(--(p)->_cnt < 0 ? \
				_flsbuf((unsigned char) (x), (p)) : \
				(int) (*(p)->_ptr++ = (unsigned char) (x)))
#define clearerr(p)     ((void) ((p)->_flag &= ~(_IOERR | _IOEOF)))
#endif

#define getchar()	getc(stdin)
#define putchar(x)	putc((x), stdout)
#define feof(p)		((p)->_flag & _IOEOF)
#define ferror(p)	((p)->_flag & _IOERR)

#endif /* lint */



#pragma pack()

#endif /* _STDIO_H */
