/*
 *   Copyright (C) 1984-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _STDLIB_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _STDLIB_H

#ident "oldstyle @(#) stdlib.h 20.1 94/12/04 "


#pragma pack(4)

#ifndef _DIV_T
#define _DIV_T
typedef	struct
{
	int	quot;
	int	rem;
} div_t;
#endif

#ifndef _LDIV_T
#define _LDIV_T
typedef struct
{
	long	quot;
	long	rem;
} ldiv_t;
#endif

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int	size_t;
#endif

#if !defined(_SSIZE_T)
#define _SSIZE_T
typedef int	ssize_t;
#endif

#ifndef _WCHAR_T
#define _WCHAR_T
typedef long	wchar_t;
#endif

#ifndef NULL
#define NULL	0
#endif /* NULL */

#define EXIT_FAILURE	1
#define EXIT_SUCCESS	0
#define RAND_MAX	077777


/* From sys/wait.h */
#define WNOHANG          0001
#define WUNTRACED   0002
#define WEXITSTATUS(sv)  ((sv >> 8) & 0xff)
#define WIFEXITED(sv)    ((sv & 0xff) == 0)
#define WIFSIGNALED(sv)  ((sv) && (sv == (sv & 0x00ff)))
#define WIFSTOPPED(sv)   ((sv & 0xff) == 0177)
#define WSTOPSIG(sv)     ((sv >> 8) & 0xff)
#define WTERMSIG(sv)     (sv & 0x7f)


extern unsigned char	_ctype[];

#define MB_CUR_MAX	((int)_ctype[520])

extern double	atof _PARAMS((const char *));
extern int	atoi _PARAMS((const char *));
extern long	atol _PARAMS((const char *));
extern double	strtod _PARAMS((const char *, char **));
extern float	strtof();
extern long	strtol _PARAMS((const char *, char **, int));
extern unsigned long	strtoul _PARAMS((const char *, char **, int));

extern int	rand();
extern void	srand _PARAMS((unsigned int));

extern char	*calloc _PARAMS((__SIZE_TYPE__ , __SIZE_TYPE__ ));
extern void	free _PARAMS((void *));
extern char	*malloc _PARAMS((__SIZE_TYPE__ ));
extern char	*realloc _PARAMS((void *, __SIZE_TYPE__ ));

extern void	abort();
extern int	atexit _PARAMS((void (*) (void)));
extern void	exit _PARAMS((int));
extern char	*getenv _PARAMS((const char *));
extern int	system _PARAMS((const char *));

extern char	*bsearch _PARAMS((const void *, const void *, __SIZE_TYPE__ , __SIZE_TYPE__ , int (*) (const void *, const void *)));
extern void	qsort _PARAMS((void *, __SIZE_TYPE__ , __SIZE_TYPE__ , int (*) (const void *, const void *)));

extern int	abs _PARAMS((int));
extern div_t	div _PARAMS((int, int));
extern long	labs _PARAMS((long int));
extern ldiv_t	ldiv _PARAMS((long int, long int));

extern int	mbtowc _PARAMS((__WCHAR_TYPE__ *, const char *, __SIZE_TYPE__ ));
extern int	mblen _PARAMS((const char *, __SIZE_TYPE__ ));
extern int	wctomb _PARAMS((char *, __WCHAR_TYPE__ ));

extern size_t	mbstowcs _PARAMS((__WCHAR_TYPE__ *, const char *, __SIZE_TYPE__ ));
extern size_t	wcstombs _PARAMS((char *, const __WCHAR_TYPE__ *, __SIZE_TYPE__ ));

extern long	a64l _PARAMS((const char *));
extern int	dup2 _PARAMS((int, int));
extern char	*ecvt _PARAMS((double, int, int *, int *));
extern char	*ecvtl();
extern char	*fcvt _PARAMS((double, int, int *, int *));
extern char	*fcvtl();
extern char	*getcwd _PARAMS((char *, __SIZE_TYPE__ ));
extern char	*getlogin();
extern int	getopt _PARAMS((int, char *const *, const char *));
extern int	getsubopt _PARAMS((char **, char *const *, char **));
extern char	*optarg;
extern int	optind, opterr, optopt;
extern char	*getpass _PARAMS((const char *));
extern int	getpw _PARAMS((int, char *));
extern char	*gcvt _PARAMS((double, int, char *));
extern char	*gcvtl();
extern int	grantpt();
extern char	*initstate _PARAMS((unsigned, char *, int));
extern int	isatty _PARAMS((int));
extern void	l3tol _PARAMS((long int *, const char *, int));
extern char	*l64a _PARAMS((long int));
extern char	*l64a_r();
extern void	ltol3 _PARAMS((char *, const long int *, int));
extern char	*memalign _PARAMS((__SIZE_TYPE__ , __SIZE_TYPE__ ));
extern int	mkstemp _PARAMS((char *));
extern char	*mktemp _PARAMS((char *));
extern int	rand_r();
extern char	*ptsname();
extern long	random();
extern void	srandom _PARAMS((int));
extern char	*realpath _PARAMS((char *, char *));
extern void	swab _PARAMS((const char *, char *, int));
extern char	*ttyname _PARAMS((int));
extern int	ttyslot();
extern int	unlockpt();
extern char	*valloc _PARAMS((__SIZE_TYPE__ ));
extern double	wcstod();
extern float	wcstof();
extern long	wcstol();
extern long double	wcstold();
extern unsigned long	wcstoul();



extern int	putenv _PARAMS((char *));
extern double	drand48();
extern double	erand48 _PARAMS((short unsigned int *));
extern long	jrand48 _PARAMS((short unsigned int *));
extern void	lcong48 _PARAMS((short unsigned int *));
extern long	lrand48();
extern long	mrand48();
extern long	nrand48 _PARAMS((short unsigned int *));
extern unsigned short	*seed48 _PARAMS((short unsigned int *));
extern void	setkey _PARAMS((const char *));
extern void	srand48 _PARAMS((long int));



#define mblen(s, n)	mbtowc((wchar_t *)0, s, n)


#pragma pack()

#endif /* _STDLIB_H */
