/*
 *   Portions Copyright (C) 1983-1995 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _STRING_H
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
#define _STRING_H

#ident "oldstyle @(#) string.h 20.1 94/12/04 "


#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int	size_t;
#endif

#ifndef NULL
#define NULL	0
#endif /* NULL */



extern char
	*strcpy _PARAMS((char *, const char *)),
	*strncpy _PARAMS((char *, const char *, __SIZE_TYPE__ )),
	*strcat _PARAMS((char *, const char *)),
	*strncat _PARAMS((char *, const char *, __SIZE_TYPE__ )),
	*strchr _PARAMS((const char *, int)),
	*strrchr _PARAMS((const char *, int)),
	*strpbrk _PARAMS((const char *, const char *)),
	*strtok _PARAMS((char *, const char *)),
	*strtok_r(),
	*strdup(),
	*strstr _PARAMS((const char *, const char *)),
	*strerror _PARAMS((int)),
	*strlist();

extern int
	strcmp _PARAMS((const char *, const char *)),
	strncmp _PARAMS((const char *, const char *, __SIZE_TYPE__ )),
	strcoll _PARAMS((const char *, const char *)),
/* Made int for _SVID compliance */
	strlen _PARAMS((const char *)),
	strspn _PARAMS((const char *, const char *)),
	strcspn _PARAMS((const char *, const char *));
extern size_t
	strxfrm _PARAMS((char *, const char *, __SIZE_TYPE__ ));
extern char
	*memccpy _PARAMS((void *, const void *, int, __SIZE_TYPE__ )),
	*memchr _PARAMS((const void *, int, __SIZE_TYPE__ )),
	*memcpy _PARAMS((void *, const void *, __SIZE_TYPE__ )),
	*memmove _PARAMS((void *, const void *, __SIZE_TYPE__ )),
	*memset _PARAMS((void *, int, __SIZE_TYPE__ ));
extern int memcmp _PARAMS((const void *, const void *, __SIZE_TYPE__ ));

extern void perror _PARAMS((const char *));
extern char *strdup _PARAMS((const char *));
extern int     strncoll();
extern size_t  strnxfrm();
extern int nl_strcmp();
extern int nl_strncmp();



#endif /* _STRING_H */
