/* Copyright 1994-1995 The Santa Cruz Operation, Inc. All Rights Reserved. */


#if defined(_NO_PROTOTYPE)	/* Old, crufty environment */
#include <oldstyle/unistd.h>
#elif defined(_XOPEN_SOURCE) || defined(_XPG4_VERS)	/* Xpg4 environment */
#include <xpg4/unistd.h>
#elif defined(_POSIX_SOURCE) || defined(_POSIX_C_SOURCE) /* Posix environment */
#include <posix/unistd.h>
#elif defined(_SCO_ODS_30) /* Old, Tbird compatible environment */
#include <ods_30_compat/unistd.h>
#else 	/* Normal, default environment */
/*
 *   Copyright (C) The Santa Cruz Operation, Inc., 1988-1995
 *		All Rights Reserved.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*	Portions Copyright (c) 1990, 1991, 1992, 1993 UNIX System Laboratories, Inc. */
/*	Portions Copyright (c) 1979 - 1990 AT&T   */
/*	  All Rights Reserved   */

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF          */
/*	UNIX System Laboratories, Inc.                          */
/*	The copyright notice above does not evidence any        */
/*	actual or intended publication of such source code.     */

#ifndef _UNISTD_H
#define _UNISTD_H

#pragma comment(exestr, "xpg4plus @(#) unistd.h 20.1 94/12/04 ")

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>
#include <sys/unistd.h>


#ifdef _EFF_SUPPORT
#define EFF_ONLY_OK 	010	/* Test using effective ids  */
#endif

#ifdef _VERY_STRANGE
#define EX_OK		020	/* Test for Regular, executable file  */
#endif


#ifndef NULL
#define NULL	0
#endif /* NULL */


extern int	access(const char *, int);
extern unsigned	alarm(unsigned);
extern int	chdir(const char *);
extern int	chown(const char *, uid_t, gid_t);
extern int	close(int);
extern char	*cuserid(char *);
extern int	dup(int);
extern int	dup2(int, int);
extern int	execl(const char *, const char *, ...);
extern int	execle(const char *, const char *, ...);
extern int	execlp(const char *, const char *, ...);
extern int	execv(const char *, char *const *);
extern int	execve(const char *, char *const *, char *const *);
extern int	execvp(const char *, char *const *);
extern void	_exit(int);
extern pid_t	fork(void);
extern long	fpathconf(int, int);
extern char	*getcwd(char *, size_t);
extern gid_t	getegid(void);
extern uid_t	geteuid(void);
extern gid_t	getgid(void);
extern int	getgroups(int, gid_t *);
extern char	*getlogin(void);
extern pid_t	getpgrp(void);
extern pid_t	getpid(void);
extern pid_t	getppid(void);
extern uid_t	getuid(void);
extern int	isatty(int);
extern int	link(const char *, const char *);
extern off_t	lseek(int, off_t, int);
extern long	pathconf(const char *, int);
extern int	pause(void);
extern int	pipe(int *);
extern ssize_t	read(int, void *, size_t);
extern int	rmdir(const char *);
extern int	setgid(gid_t);
extern int	setpgid(pid_t, pid_t);
extern pid_t	setsid(void);
extern int	setuid(uid_t);
extern unsigned	sleep(unsigned);
extern long	sysconf(int);
extern pid_t	tcgetpgrp(int);
extern int	tcsetpgrp(int, pid_t);
extern char	*ttyname(int);
extern int	unlink(const char *);
extern ssize_t	write(int, const void *, size_t);


extern size_t	confstr(int, char *, size_t);
extern int	getopt(int, char *const*, const char *);
extern char	*optarg;
extern int	optind, opterr, optopt;



extern int	chroot(const char *);
extern char	*crypt(const char *, const char *);
extern char	*ctermid(char *);	/* REALLY OKAY HERE?  */
extern void	encrypt(char *, int);
extern int	fsync(int);
extern char	*getpass(const char *);
extern int	nice(int);
extern void	swab(const void *, void *, ssize_t);



extern int	acct(const char *);
extern int	brk(void *);
extern void	exit(int);
extern int	eaccess(const char *, int );
extern int	fattach(int, const char *);
extern int	fchdir(int);
extern int	fchown(int, uid_t, gid_t);
extern int	fdetach(const char *);
extern int	ftruncate(int, off_t);
extern int	getdtablesize(void);
extern long	gethostid(void);
extern int	gethostname(char *, int);
extern char	*getlogin_r(char *, size_t);
extern int	getpagesize(void);
extern char	*getpass_r(const char *, char *, size_t);
extern pid_t	getpgid(pid_t);
extern char	*gettxt(const char *, const char *);
extern pid_t	getsid(pid_t);
extern char	*getwd(char *);
extern int	ioctl(int, int, ...);
extern int	lchown(const char *, uid_t, gid_t);
extern int	lockf(int, int, long);
extern void	profil(unsigned short *, size_t, int, unsigned);
extern int	ptrace(int, pid_t, int, int);
extern int	readlink(const char *, void *, int);
extern int	rename(const char *, const char *);
extern void	*sbrk(int);
extern int	setgroups(int, const gid_t *);
extern pid_t	setpgrp(void);
extern int	setregid(gid_t, gid_t);
extern int	setreuid(uid_t, uid_t);
extern int	stime(const time_t *);
extern int	symlink(const char *, const char *);
extern void	sync(void);
extern int	truncate(const char *, off_t);
extern char	*ttyname_r(int, char *, size_t);
extern unsigned int	ualarm(unsigned int, unsigned int);
extern int	usleep(unsigned int);
extern pid_t	vfork(void);



#ifdef __cplusplus
}
#endif

#endif /* _UNISTD_H */
#endif
